unit Umail;
   
interface
   
uses
   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, StdCtrls, ExtCtrls, Grids, Outline, Buttons, mailto,mbutil,
   FileCtrl, Menus, usend, Ledgadgt, Balloon, AnaClock, uoptions, PGTray95;
   
type
   Tmainf = class(TForm)
      Panel1: TPanel;
      Memo1: TMemo;
      SpeedButton1: TSpeedButton;
      SpeedButton3: TSpeedButton;
      SpeedButton5: TSpeedButton;
      SpeedButton4: TSpeedButton;
      SpeedButton6: TSpeedButton;
      FileListBox1: TFileListBox;
      Panel2: TPanel;
      Outline1: TOutline;
      StringGrid1: TStringGrid;
      BitBtn1: TBitBtn;
      PopupMenu1: TPopupMenu;
      SaveMail1: TMenuItem;
      DeteteMail1: TMenuItem;
      N1: TMenuItem;
      ReplyMail1: TMenuItem;
      SaveDialog1: TSaveDialog;
      BalloonHint1: TBalloonHint;
      timer1: TAnalogClock;
      FileListBox2: TFileListBox;
      MainMenu1: TMainMenu;
      Options1: TMenuItem;
      Compose1: TMenuItem;
      Exit1: TMenuItem;
      CheckBox1: TCheckBox;
{    TrayIcon1: TTrayIcon;}
      PopupMenu2: TPopupMenu;
      ShowMails1: TMenuItem;
      MenuItem1: TMenuItem;
      MenuItem2: TMenuItem;
      TrayIcon1: TPGTrayIcon95;
      Panel3: TPanel;
      SpeedButton2: TSpeedButton;
      Label1: TLabel;
      procedure FormCreate(Sender: TObject);
      procedure SpeedButton6Click(Sender: TObject);
      procedure Outline1Click(Sender: TObject);
      procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
      procedure StringGrid1Click(Sender: TObject);
      procedure SaveMail1Click(Sender: TObject);
      procedure DeteteMail1Click(Sender: TObject);
      procedure ReplyMail1Click(Sender: TObject);
      procedure SpeedButton3Click(Sender: TObject);
      procedure StringGrid1DblClick(Sender: TObject);
      procedure timer1Timer(Sender: TObject);
      procedure SpeedButton1Click(Sender: TObject);
      procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
      procedure SpeedButton4Click(Sender: TObject);
      procedure MenuItem2Click(Sender: TObject);
      procedure ShowMails1Click(Sender: TObject);
      procedure BitBtn1Click(Sender: TObject);
      procedure TrayIcon1DblClick(Sender: TObject);
      procedure SpeedButton2Click(Sender: TObject);
   private
      
      st1,st2,st3,st4 : tstringlist;
      thest : byte; {indicate 1: inbox, 2: old, 3 : send}
      mm: array[0..100] of byte;
      ct1,ct2,ct3 : word;
      minu : byte;
      Lastfile : string[60];
      procedure filldata;
      procedure updateit;
      function HookProc(var Message: TMessage): boolean;
   public
      
   end;
      
var
   mainf: Tmainf;
   
implementation

{$R *.DFM}

function new_mail : boolean;
begin
   new_mail := mainf.st1.count < mainf.st2.count;
end;

procedure Tmainf.filldata;
var i: word;
begin
   ct1:= 0;
   ct2 := 0;
   ct3 := 0;
   st1.clear;
   st2.clear;
   st3.clear;
   st4.clear;
   try
      st1.loadfromfile(ffilename + 'mails.ndx');
   except
   end;
   filelistbox1.directory :='C:\';
   filelistbox1.directory := ffilename;
   filelistbox1.refresh;
   for i:= 0 to filelistbox1.items.count - 1 do
      if (pos('login',filelistbox1.items[i]) <> 0)
   or (pos('mails.ndx',filelistbox1.items[i]) <> 0)
   then
      else
      if pos('.cnm',filelistbox1.items[i]) <> 0 then
      begin
         inc(ct1);
         st2.add(filelistbox1.items[i]);
      end
      else
         if  pos('.~',filelistbox1.items[i]) <> 0 then
         begin
            inc(ct2);
            st3.add(filelistbox1.items[i]);
         end
         else
            if  pos('.snt',filelistbox1.items[i]) <> 0 then
            begin
               inc(ct3);
               st4.add(filelistbox1.items[i]);
            end;
            outline1.items[2].text :='Inbox       : '+ inttostr(ct1);
            outline1.items[3].text :='Old mails : '+ inttostr(ct2);
            outline1.items[4].text :='Sent mails : '+ inttostr(ct3);
            if new_mail then caption := 'Mik''s Mail utility '+ '   * New Mails';
         end;

function Tmainf.HookProc(var Message: TMessage): boolean;
begin
   Result := false;
   if Message.Msg = WM_EndSession then
   begin
      if WordBool(Message.wParam) then
      begin
         close;
         Halt;
      end;
   end;
END;

procedure Tmainf.FormCreate(Sender: TObject);
var  i2,i3:byte;
   s : string;
begin
   lastfile := '';
   if hprevinst > 0 then halt;
   s := utilGetdosVersion;
   if s[1] = '7' then
      TrayIcon1.active := true;
   Application.HookMainWindow(HookProc);
   left := -5000;
   {showwindow(application.handle, sw_hide);}
   getdata;
   minu := 0;
   fillchar(mm,sizeof(mm),0);
   st1 := tstringlist.create;
   st2 := tstringlist.create;
   st3 := tstringlist.create;
   st4 := tstringlist.create;
   stringgrid1.cells[1,0] := 'Sender';
   stringgrid1.cells[2,0] := 'Title';
   stringgrid1.cells[3,0] := 'Date/Time';
   i3 := outline1.add(0, mailto.sender);
   i2 := outline1.addchild(i3,'Inbox       : '+ inttostr(ct1));
   i2 := outline1.addchild(i3,'Old mails : '+ inttostr(ct2));
   i2 := outline1.addchild(i3,'Sent mails : '+ inttostr(ct3));
   outline1[1].expand;
   filldata;
end;

procedure Tmainf.SpeedButton6Click(Sender: TObject);
begin
   visible := false;
end;

procedure Tmainf.Outline1Click(Sender: TObject);
var s : string;
   i: word;
   n : byte;
   ss : tstringlist;
begin
   panel3.visible := false;
   stringgrid1.row := stringgrid1.fixedrows;
   stringgrid1.col := stringgrid1.fixedcols;
   thest := 0;
   memo1.lines.clear;
   for i := 1 to stringgrid1.rowcount -1 do
      stringgrid1.rows[i].clear;
   s := outline1.items[outline1.selecteditem].text;
   if  (pos('Inbox',s) <> 0) then
   begin
      thest := 1;
      ss := st2;
   end
   else
      if  (pos('Old',s) <> 0) then
      begin
         thest := 2;
         ss := st3;
      end
      else
         if  (pos('Sent',s) <> 0) then
         begin
            thest := 3;
            ss := st4;
         end;

         if (thest > 0) and (ss.count > 0)
         then
         begin
            for i := 0 to ss.count -1 do
            begin
               if thest = 1 then
                  if mm[i] = 1 then
                  stringgrid1.cells[0,i] := '*';
               st1.loadfromfile(ss.strings[i]);

               s := st1.strings[0];
               n :=pos('|',s);
               stringgrid1.cells[1,i+1] := copy(s,1,n-1);
               delete(s,1,n);
               n:=pos('|',s);
               stringgrid1.cells[2,i+1] := copy(s,1,n-1);
               delete(s,1,n);
               stringgrid1.cells[3,i+1] := s;
            end;
         end

      end;

procedure tmainf.updateit;
var i : byte;
   f : file;
begin
   st1.clear;
   if st2.count > 0 then
      for i:= 0 to st2.count - 1 do
      if mm[i+1] = 0
   then
      st1.add(st2.strings[i])
   else
   begin
      assignfile(f,st2.strings[i]);
      rename(f,copy(st2.strings[i],1,pos('.',st2.strings[i])) + '~');
   end;
   if st1.count > 0 then
      st1.savetofile(ffilename + 'mails.ndx');
end;

procedure Tmainf.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   putdata;
   updateit;
   st1.free;
   st2.free;
   st3.free;
   st4.free;
   users.free;
   TrayIcon1.active := FALSE;
   application.terminate;
end;

procedure Tmainf.StringGrid1Click(Sender: TObject);
var
   i : byte;
   thefile : string[60];
   s: string[80];
begin
   thefile := '';
   SPEEDBUTTON4.ENABLED := FALSE;
   if StringGrid1.col = 0 then
   begin
      if StringGrid1.cells[0,StringGrid1.row] = '*' then
      begin
         StringGrid1.cells[0,StringGrid1.row] := '';
         mm[StringGrid1.row] := 0;
      end;
      exit;
   end;

   if thest = 1 then
      if StringGrid1.row  > st2.count then exit;
   if thest = 2 then
      if StringGrid1.row  > st3.count then exit;
   if thest = 3 then
      if StringGrid1.row  > st4.count then exit;

   case thest of
      1: begin
         SPEEDBUTTON4.ENABLED := TRUE;
         usend.rfile := st2.strings[stringgrid1.row-1];
         thefile :=st2.strings[StringGrid1.row - 1];
         StringGrid1.cells[0,StringGrid1.row] := '*';
         mm[StringGrid1.row] := 1;
      end;
      2: begin
         SPEEDBUTTON4.ENABLED := TRUE;
         usend.rfile := st3.strings[stringgrid1.row-1];
         thefile := usend.rfile;
      end;
      3: thefile := st4.strings[StringGrid1.row - 1];
   end; {case}
   if thefile = '' then exit;
   if thefile <> lastfile then
   begin
      screen.cursor := -11;
      memo1.lines.loadfromfile(ffilename + thefile);
      lastfile := thefile;
      speedbutton2.hint := '';
      panel3.visible := false;
      if memo1.lines.count > 0 then
      begin
         s:= memo1.lines[5];
         if pos('*',s) > 0 then
         begin
            panel3.visible := true;
            speedbutton2.hint := copy(s,pos('*',s) +1,40);
            delete(s,pos('*',s),12);
            memo1.lines[5] := s;
         end;
      end;
      memo1.lines.delete(0);

      if not checkbox1.checked then
         for i := 1 to 5 do
         memo1.lines.delete(0);
      screen.cursor := 0;
   end;
end;

procedure Tmainf.SaveMail1Click(Sender: TObject);
var ss : string;
begin
   if thest <1 then exit;
   case thest of
      0 : exit;
      1: ss := st2.strings[stringgrid1.row-1];
      2: ss := st3.strings[stringgrid1.row-1];
      3: ss := st4.strings[stringgrid1.row-1];
   end;
   savedialog1.filename := copy(ss,1,pos('.',ss)) + 'txt';
   if savedialog1.execute then
   begin
      ss := savedialog1.filename;
      if ss <> '' then
      begin
         memo1.lines.savetofile(ss);
      end;
   end;
end;

procedure Tmainf.DeteteMail1Click(Sender: TObject);
var ss : string;
   mmm : tstringlist;
begin
   case thest of
      0:exit;
      1: begin
         mmm := st2;
      end;
      2: begin
         mmm := st3;
      end;
      3: begin
         mmm := st4;
      end;
   end;
   if stringgrid1.row > mmm.count then exit;
   ss := mmm.strings[stringgrid1.row-1];
   deletefile(ffilename + ss);
   if panel3.visible and (SpeedButton2.hint <> '') then
   begin
      deletefile('F:\MAIL\'+hexid+'\'+SpeedButton2.hint);
   end;
   mmm.delete(stringgrid1.row-1);
   stringgrid1.rows[stringgrid1.row].clear;
   filldata;
   outline1click(sender);
end;

procedure Tmainf.ReplyMail1Click(Sender: TObject);
begin
   if usend.rfile = '' then exit;
   usend.reply := true;
   fsend.showmodal;
   if usend.hassent then
   begin
      filldata;
      Outline1Click(sender);
   end;
end;

procedure Tmainf.SpeedButton3Click(Sender: TObject);
begin
   timer1.enabled := false;
   fsend.showmodal;
   timer1.enabled := true;
   if usend .hassent then
   begin
      filldata;
      Outline1Click(sender);
   end;

end;

procedure Tmainf.StringGrid1DblClick(Sender: TObject);
begin
   if StringGrid1.cells[0,StringGrid1.row] = '*' then
   begin
      StringGrid1.cells[0,StringGrid1.row] := '';
      mm[StringGrid1.row] := 0;
   end;

end;

procedure Tmainf.timer1Timer(Sender: TObject);
VAR CC : INTEGER;
begin
   inc(minu);
   if minu = timing then
   begin
      minu := 0;
      CC := st2.count;
      FILLDATA;
      IF st2.count > CC then
      begin
         messagebeep(10);
         trayicon1.State:= tsDisabled;
         if popup then
            application.MESSAGEbox('You have new mail(s)','Novell Email',mb_ok + MB_ICONINFORMATION) ;
      end;
   end;
end;

procedure Tmainf.SpeedButton1Click(Sender: TObject);
begin
   timer1.enabled := false;
   foptions.showmodal;
   timer1.enabled := true;
end;

procedure Tmainf.StringGrid1KeyDown(Sender: TObject; var Key: Word;
Shift: TShiftState);
var i : byte;
begin
   if key = vk_delete then
   begin
      DeteteMail1Click(sender);
      Outline1Click(sender);
   end;
end;

procedure Tmainf.SpeedButton4Click(Sender: TObject);
begin
   usend.reply := true;
   FSEND.SHOWMODAL;
end;

procedure Tmainf.MenuItem2Click(Sender: TObject);
begin
   close;
end;

procedure Tmainf.ShowMails1Click(Sender: TObject);
begin
   left := 10;
   visible := true;
   panel3.visible := false;
   trayicon1.State := tsEnabled;
end;

procedure Tmainf.BitBtn1Click(Sender: TObject);
begin
   DeteteMail1Click(sender);
end;

procedure Tmainf.TrayIcon1DblClick(Sender: TObject);
begin
   ShowMails1Click(sender);
end;

procedure Tmainf.SpeedButton2Click(Sender: TObject);
var ss: string;
   f: tmemorystream;
begin
   if SpeedButton2.hint <> '' then
   begin
      savedialog1.filename := SpeedButton2.hint;
      if savedialog1.execute then
      begin
         ss := savedialog1.filename;
         f:= tmemorystream.create;
         f.loadfromfile('f:\MAIL\'+hexid+'\' + SpeedButton2.hint);
         try
            f.savetofile(ss);
         except
            showmessage('Cannot save to ' + ss);
         end;
         f.free;
      end;
   end;
end;

initialization
begin
   showwindow(application.handle, sw_hide);
end;

end.
