unit Usend;
   
interface
   
uses
   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, mailto, novell;
   
type
   Tfsend = class(TForm)
      Panel1: TPanel;
      Label1: TLabel;
      Label2: TLabel;
      Label3: TLabel;
      Label4: TLabel;
      ComboBox1: TComboBox;
      Edit1: TEdit;
      Edit2: TEdit;
      SpeedButton1: TSpeedButton;
      Edit3: TEdit;
      Button1: TButton;
      Button2: TButton;
      Memo1: TMemo;
      CheckBox1: TCheckBox;
      OpenDialog1: TOpenDialog;
      procedure Button2Click(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure Button1Click(Sender: TObject);
      procedure Memo1Change(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure CheckBox1Click(Sender: TObject);
      procedure SpeedButton1Click(Sender: TObject);
   private
{ Private declarations }
      procedure getdatafrommemo;
   public
{ Public declarations }
   end;
      
var
   fsend: Tfsend;
   hassent : boolean;
   reply : boolean;
   rfile : string;

implementation

{$R *.DFM}

procedure Tfsend.Button2Click(Sender: TObject);
begin
   close;
end;

procedure Tfsend.FormCreate(Sender: TObject);
var i :byte;
begin
   if users.count > 0 then
      for i := 0 to users.count - 1 do
      combobox1.items.add(users.strings[i]);
end;

PROCEDURE SAVE_ATTACH(F:STRING;DIR : STRING);
var t : tMemorystream;
   fname : string;
Begin
   if f = '' then exit;
   if not fileexists(f) then exit;
   t := tMemorystream.create;
   t.loadfromfile(f);
   fname := extractfilename(f);
   t.savetofile(dir + fname);
   t.free;
end;

procedure Tfsend.Button1Click(Sender: TObject);
var s : string;
   tid : string;
   i : byte;
begin
   get_server_datetime(year,month,day,hour,minute,second,dow);
   target:=combobox1.text;
   gethexid(target,tid,retcode);
   if retcode<>0 then
   begin
      showmessage('No user '+ target + ' found on this server.');
      showmessage('This utility can only send messages to known users on your default server.');
      exit;
   end;
   if memo1.lines.count < 1 then
   begin
      showmessage('Nothing to mail');
      exit;
   end;
   ffilename:='f:\MAIL\'+tid+'\';
   randomize;
   try
      if pos('|',memo1.lines[0]) = 0 then
      begin
         s :=mailto.sender +'|'+ edit3.text+'|'+
         INTTOSTR(DAY)+'/'+INTTOSTR(MONTH)+'/'+
         INTTOSTR(YEAR)+' '+INTTOSTR(HOUR)+':'+
         INTTOSTR(MINUTE)+':'+INTTOSTR(SECOND);
         memo1.lines.insert(0,s);

         memo1.lines.insert(1,'From:     '+mailto.sender);
         memo1.lines.insert(2,'To:       '+target);
         s:= 'Date:     '+ inttostr(day) +' '+months[month]+' '+zstr(year)+' '
         +zstr(hour)+':'+zstr(minute)+':'+zstr(second);
         memo1.lines.insert(3,s);
         memo1.lines.insert(4,'Subject:  '+edit3.text);
         if EDIT2.TEXT <> '' then
            memo1.lines.insert(5,'Mailer:  Novell Mail for Michael '+ ver + '*' + extractfilename(edit2.text))
         else
            memo1.lines.insert(5,'Mailer:  Novell Mail for Michael '+ ver);
      end;
      s := '';
      for i:=1 to 8 do
         s:=s+chr(ord('A')+random(26));
      memo1.lines.savetofile(ffilename + s+ '.CNM');
      ffilename:='f:\MAIL\'+hexid+'\';
      memo1.lines.savetofile(ffilename + s+ '.snt');

      SAVE_ATTACH(EDIT2.TEXT,'f:\MAIL\'+tid+'\');

      SAVE_ATTACH(EDIT2.TEXT,'f:\MAIL\'+hexid+'\');

      button1.enabled := false;
      hassent := true;
      send_message_to_username(target,'Mail from '+ mailto.sender+', '+
      zstr(hour)+':'+zstr(minute)+': "'+subject+'"',retcode);
      close;
   except
      showmessage('Cannot mail!');
   end;

end;

procedure Tfsend.Memo1Change(Sender: TObject);
begin
   button1.enabled := true;
end;

procedure Tfsend.FormShow(Sender: TObject);
VAR ST : TSTRINGLIST;
   S : STRING[40];
begin
   hassent := false;
   checkbox1.visible := reply;
   IF REPLY THEN
   BEGIN
      ST := TSTRINGLIST.CREATE;
      ST.LOADFROMFILE('f:\MAIL\'+hexid+'\' + RFILE);
      S := COPY(ST.STRINGS[4],11,40);
      EDIT3.TEXT := S;
      S := COPY(ST.STRINGS[1],11,40);
      COMBOBOX1.TEXT := S;
      st.free;
   END;
end;

procedure Tfsend.getdatafrommemo;
var sd : string[40];
begin
   SD :=   memo1.lines[4];
   DELETE(SD,1,10);
   EDIT3.TEXT := SD;
   SD  := MEMO1.LINES[1];
   DELETE(SD,1,10);
   COMBOBOX1.TEXT := SD;
end;

procedure Tfsend.CheckBox1Click(Sender: TObject);
var i : byte;
   s : string;
begin
   if CheckBox1.checked then
   begin
      memo1.LINES.loadfromfile('f:\MAIL\'+hexid+'\' + rfile);
      getdatafrOmmemo;
      memo1.lines.delete(0);
      memo1.lines.insert(0,+ COMBOBOX1.TEXT + ' WROTE : >>');
      for i := 1 to  memo1.lines.count - 1 do
      begin
         s:=memo1.lines[i];
         insert('>',s,1);
         memo1.lines[i] := s;
      end;
   end;

end;

procedure Tfsend.SpeedButton1Click(Sender: TObject);
begin
   IF OPENDIALOG1.EXECUTE THEN
      EDIT2.TEXT := OPENDIALOG1.FILENAME;
end;

end.
